#include <File.au3>
#include <Typos.au3>
#include <Array.au3>

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>

#cs
1.0 = * Initial release.
1.1 = * Remove any non ASCII chars from cleaned up name. Improves match percentage.
	  * Replace II with 2 etc, Up to 8. Improves match percentage.
	  * Rewritten some comparison parts for a little speed upgrade. Not much though.
	  * It wont ask for any user input until the end when everything is matched up.
1.2 = * If a direct match is found, that source is removed from the array so it is not matched
        with again. Improves speed by a lot if the sourcefiles have a lot of 0 mispelled items.
	  * Dupes will not be added to the source array. No reason to check the same file more then once.
#ce

Global $Version = "1.2"
Global $MediaDestination = "UNKNOWN"

Local $aArray_RomsListCleaned[0][3]
Local $aArray_SourceListCleaned[0][2]
Local $aArray_FinishedList[0][6]
Local $aArray_FinishedAutoList[0][6]
Local $aArray_NotFound[0][5]

HotKeySet("+{ESC}", "_Quit")

MsgBox(0, "Tur-Matcher " & $Version & " by Turranius", "We will now ask you a number of questions." & @CRLF & @CRLF & "Please see the title of each box that pops up for what we are asking for." & @CRLF & @CRLF & "You can press Shift-Escape at any time to quit/abort (if there is a messagebox up, you have to click on it before it exits).")

$Reply = MsgBox(32 + 4, "Use XML?", "Do you want to use an XML (database) or just use your Roms as source?" & @CRLF & @CRLF & "Press Yes for XML file or No for Roms" & @CRLF & @CRLF & @CRLF & "Please note that this does not HAVE to be the roms. This simply has to be the XML or folder that contains the names you want to use.")

If $Reply = "6" Then
;   $RomXML = "I:\Arcade\HyperSpin\Databases\Commodore 64\Commodore 64.xml"
	Global $RomXML = FileOpenDialog("Select Database XML", "", "XML files (*.XML)", 1)
	If $RomXML = "" Then
	  MsgBox(16, "Error", "Got no XML location. Aborting")
	  Exit
   EndIf
Else
   $RomXML = ""
;   $RomFolder = "I:\Arcade\Roms\Commodore 64"
   Global $RomFolder = FileSelectFolder("Please browse to the rom folder you want to use for sourcenames.", "")
   If $RomFolder = "" Then
	  MsgBox(16, "Error", "Got no Rom location. Aborting")
	  Exit
   EndIf
EndIf

Global $HitLimit = ""
$HitLimit = InputBox("Threshold", "Enter the number differences that constitutes a match. Setting this too high will get false positives. Setting it to 0 will be exact match only.", "2")
If $HitLimit = "" Then
   Exit
EndIf

Global $AutoCopyLimit = ""
$AutoCopyLimit = InputBox("AutoCopy Threshold", "Enter the threashhold to use for automatic copy without questions. 0 = Only exact matches. -1 = Disable Autocopy.", "0")
If $AutoCopyLimit = "" Then
   Exit
EndIf

;$SourceFolder = "I:\Arcade\Others\Commodore 64 offical vids\pics"
Global $SourceFolder = FileSelectFolder("Please browse to the source folder for media.", "")

If $SourceFolder = "" Then
   MsgBox(16, "Error", "Got no location. Aborting")
   Exit
EndIf

;$DestinationFolder = "I:\Arcade\HyperSpin\Media\Commodore 64\Video"
Global $DestinationFolder = FileSelectFolder("Please browse to the destination folder for media.", "")

If $DestinationFolder = "" Then
   MsgBox(16, "Error", "Got no location. Aborting")
   Exit
EndIf

If $SourceFolder = $DestinationFolder Then
   MsgBox(16, "Error", "Source and Destination folders can not be the same.")
   Exit
EndIf

If $RomXML = "" Then ; User selected to use Roms as RomList, not the XML
   TrayTip("One moment...", "Indexing Roms. This might take a little while." , 60)
   $RomsList = _FileListToArray($RomFolder  & "\")
   If @error = 1 Then
	  MsgBox(0, "", "No Files Found in " & $RomFolder & "\")
	  Exit
   EndIf
   $Matched = "0"
   For $i = 1 To $RomsList[0]
	  $RomName = $RomsList[$i]
	  $RomNameNoExt = RemoveExtRegExp($RomName)
	  $RomNameClean = StringRegExpReplace($RomNameNoExt, "'", '') ; Removes '
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' III | III,', ' 3 ') ; Changes " III " and " III," to " 3 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' II | II,', ' 2 ') ; Changes " II " and " II," to " 2 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' IV | IV,', ' 4 ') ; Changes " IV " and " IV," to " 4 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VIII | VIII', ' 8 ') ; Changes " VIII " and " VIII," to " 8 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VII | VII,', ' 7 ') ; Changes " VII " and " VII," to " 7 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VI | VI,', ' 6 ') ; Changes " VI " and "VI," to " 6 "
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' V | V,', ' 5 ') ; Changes " V " and " VI," to " 5 "

	  $RomNameClean = StringRegExpReplace($RomNameClean, '\(.*\)', '') ; Removes (*)
	  $RomNameClean = StringRegExpReplace($RomNameClean, '\[.*\]', '') ; Removes [*]

	  $RomNameClean = StringRegExpReplace($RomNameClean, ' III$', ' 3') ; Changes " III." to " 3."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' II$', ' 2') ; Changes " II." to " 2."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' IV$', ' 4') ; Changes " IV." to " 4."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VIII$', ' 8') ; Changes " VIII." to " 8."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VII$', ' 7') ; Changes " VII." to " 7."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' VI$', ' 6') ; Changes " VI." to " 6."
	  $RomNameClean = StringRegExpReplace($RomNameClean, ' V$', ' 5') ; Changes " V." to " 5."

	  $RomNameClean = StringRegExpReplace($RomNameClean, '\W', ' ') ; Removes All non ascii chars
	  $RomNameClean = StringStripWS($RomNameClean, 7); Clean up extra whitespaces
	  _ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $RomNameClean & "|" & $RomNameNoExt )
   Next

Else ; User selected to use a XML file as RomList.
   Local $hFileOpen = FileOpen($RomXML, 0)
   If $hFileOpen = -1 Then
	  MsgBox(16, "", "An error occurred when reading the XML file.")
	  Exit
   EndIf

   $Rows = _FileCountLines($RomXML)
   For $i = 1 to $Rows

	  $line = FileReadLine($hFileOpen, $i)
	  If StringinStr($line, "<game name=") Then
		 Local $GameNameArray = StringSplit($line, '"')
		 $RomName = $GameNameArray[2]
		 If $RomName <> "" Then

			$RomName = StringReplace($RomName, '&amp;', '&') ; Cleanup of XML codes.

			$RomNameClean = StringRegExpReplace($RomName, "'", '') ; Removes '
			$RomNameClean = StringRegExpReplace($RomNameClean, ' III | III,', ' 3 ') ; Changes " III " and " III," to " 3 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' II | II,', ' 2 ') ; Changes " II " and " II," to " 2 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' IV | IV,', ' 4 ') ; Changes " IV " and " IV," to " 4 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VIII | VIII', ' 8 ') ; Changes " VIII " and " VIII," to " 8 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VII | VII,', ' 7 ') ; Changes " VII " and " VII," to " 7 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VI | VI,', ' 6 ') ; Changes " VI " and "VI," to " 6 "
			$RomNameClean = StringRegExpReplace($RomNameClean, ' V | V,', ' 5 ') ; Changes " V " and " VI," to " 5 "

			$RomNameClean = StringRegExpReplace($RomNameClean, '\(.*\)', '') ; Removes (*)
			$RomNameClean = StringRegExpReplace($RomNameClean, '\[.*\]', '') ; Removes [*]

			$RomNameClean = StringRegExpReplace($RomNameClean, ' III$', ' 3') ; Changes " III." to " 3."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' II$', ' 2') ; Changes " II." to " 2."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' IV$', ' 4') ; Changes " IV." to " 4."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VIII$', ' 8') ; Changes " VIII." to " 8."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VII$', ' 7') ; Changes " VII." to " 7."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' VI$', ' 6') ; Changes " VI." to " 6."
			$RomNameClean = StringRegExpReplace($RomNameClean, ' V$', ' 5') ; Changes " V." to " 5."

			$RomNameClean = StringRegExpReplace($RomNameClean, '\W', ' ') ; Removes All non ascii chars
			$RomNameClean = StringStripWS($RomNameClean, 7)
			_ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $RomNameClean & "|" & $RomName )
			ConsoleWrite(StringFormat($RomName & "\n"))
			TrayTip("Indexing XML file", "Row " & $i & "/" & $Rows,5)
		 EndIf
	  EndIf
   Next
   TrayTip("Indexing XML file", "Row " & $Rows & "/" & $Rows,5)
   FileClose($hFileOpen)

EndIf
_ArraySort($aArray_RomsListCleaned)
_ArrayDisplay($aArray_RomsListCleaned, "Roms found. Close this window on the upper X to continue.","",16,-1,"Rom Name|Rom Name Cleaned|Rom Name No Extensions", Default, 0xDDFFDD)

TrayTip("One Moment...", "Indexing source files",5)
$SourceList = _FileListToArray($SourceFolder  & "\")

$LastSourceNameClean = ""
For $i = 1 To $SourceList[0]
   $SourceName = $SourceList[$i]
   $SourceNameNoExt = RemoveExtRegExp($SourceName)
   $SourceNameClean = StringRegExpReplace($SourceNameNoExt, "'", '') ; Removes '
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' III | III,', ' 3 ') ; Changes " III " and " III," to " 3 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' II | II,', ' 2 ') ; Changes " II " and " II," to " 2 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' IV | IV,', ' 4 ') ; Changes " IV " and " IV," to " 4 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VIII | VIII', ' 8 ') ; Changes " VIII " and " VIII," to " 8 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VII | VII,', ' 7 ') ; Changes " VII " and " VII," to " 7 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VI | VI,', ' 6 ') ; Changes " VI " and "VI," to " 6 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' V | V,', ' 5 ') ; Changes " V " and " VI," to " 5 "
   $SourceNameClean = StringRegExpReplace($SourceNameClean, '\(.*\)', '') ; Removes (*)
   $SourceNameClean = StringRegExpReplace($SourceNameClean, '\[.*\]', '') ; Removes [*]

   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' III$', ' 3') ; Changes " III." to " 3."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' II$', ' 2') ; Changes " II." to " 2."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' IV$', ' 4') ; Changes " IV." to " 4."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VIII$', ' 8') ; Changes " VIII." to " 8."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VII$', ' 7') ; Changes " VII." to " 7."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' VI$', ' 6') ; Changes " VI." to " 6."
   $SourceNameClean = StringRegExpReplace($SourceNameClean, ' V$', ' 5') ; Changes " V." to " 5."

   $SourceNameClean = StringRegExpReplace($SourceNameClean, '\W', ' ') ; Removes All non ascii chars
   $SourceNameClean = StringStripWS($SourceNameClean, 7)
   If $LastSourceNameClean <> $SourceNameClean Then
	  _ArrayAdd($aArray_SourceListCleaned, $SourceName & "|" & $SourceNameClean )
   EndIf
   $LastSourceNameClean = $SourceNameClean
Next
_ArraySort($aArray_SourceListCleaned)
_ArrayDisplay($aArray_SourceListCleaned, "Sources Found. Close this window on the upper X to continue.","",16,-1,"Source Name|Source Name Cleaned", Default, 0xDDFFDD)

$Runs = 0
$RomsToCheck = UBound($aArray_RomsListCleaned) ; Check how many roms we have in the array.
For $i = 0 To $RomsToCheck - 1 ; Here we go. Loop through every rom in the list. (-1 is because we start at 0 but $RomsToCheck start at 1.)
   $Skip = "FALSE" ; Set this to false. We will do some checks and then we can set it to TRUE to have it skipped later.
   $RomNameNoExtension = $aArray_RomsListCleaned[$i][2] ; Get the RomName with no extension.
   If FileExists($DestinationFolder & "\" & $RomNameNoExtension & ".*") Then ; If this destination file already exists (actually checks .* so extension does not matter).
	  ConsoleWrite(StringFormat("Skipping " & $RomNameNoExtension & " as it already exists in " & $DestinationFolder & "\n" ))
	  $Skip = "TRUE" ; Destination file already exists so we can skip this item.
   EndIf

   If $Skip = "FALSE" Then ; Should we continue with this item?
	  $Runs = $Runs + 1
	  ; This is debug if we want to only run a portion of the roms.
;	  If $Runs > "50" Then
;		ExitLoop
;	  EndIf

	  ; Reset these values for each item we go through.
	  $ExactHit = "FALSE"
	  $bestMatch = ""
	  $bestMatchIdx = ""

	  ; Get the RomName and the cleaned RomName from the array of roms.
	  $RomName = $aArray_RomsListCleaned[$i][0]
	  $RomNameClean = $aArray_RomsListCleaned[$i][1]

	  ConsoleWrite(StringFormat($Runs & ": Checking " & $RomNameClean & " -> "))
	  Local $bestMatch = StringLen($RomNameClean) 							; Get the lenght of the name we're going to test first. We'll compare the results to this number.
	  $SourcesToCheck = UBound($aArray_SourceListCleaned) - 1 				; How many sources do we have in that array?
	  For $k = 0 To $SourcesToCheck 										; Go through each source in the source array!
		 $SourceNameClean = $aArray_SourceListCleaned[$k][1] 				; Get the cleaned SourceName
		 $typos = _Typos($SourceNameClean, $RomNameClean) 					; Run a comparison on SourceNameClean and RomNameClean. It will return the differences between them.
		 If $typos < $bestMatch Then 										; If this difference is lower then the previous one, its a metter match and we need to update $bestMatch and $bestMatchIdx with the better hit.
			$bestMatch = $typos
			$bestMatchIdx = $k

			If $typos = 0 Then 												; If $typos is 0, it means it an exact hit.
			   $ExactHit = "TRUE" 											; We need this for later.
			   ExitLoop 													; Exit the loop through the sources. No need to if we found a perfect match already. Speeds things up.
			EndIf
		 EndIf
	  Next

	  ; Nothing found...
	  If $bestMatchIdx = "" AND $ExactHit = "FALSE" Then
		 $bestMatchIdx = "NA"
		 $BestMatchName = "Nothing"
		 $bestMatch = "Nothing"
		 ConsoleWrite(StringFormat("No hit for " & $RomName & "\n"))
		 TrayTip("No hit for " & $RomName, "",5)
	  Else
		 $BestMatchName = $aArray_SourceListCleaned[$bestMatchIdx][0]	; Get the best matched fullname
		 $BestMatchNameExt = _FileGetExt($BestMatchName)				; Get the extension from the best matched fullname. That will be the destination extension.
		 $BestMatchNameCleaned = $aArray_SourceListCleaned[$bestMatchIdx][1] ; Also get the best matched cleaned name.
		 ConsoleWrite(StringFormat("Best match : " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors\n"))
		 TrayTip($i & "/" & $RomsToCheck & " - Best match for " & $RomNameClean, $BestMatchNameCleaned & " (" & $bestMatch & ") Sources:" & $SourcesToCheck,5)

		 If $HitLimit +1 > $bestMatch Then
			If $AutoCopyLimit >= $bestMatch Then
			   _ArrayAdd($aArray_FinishedAutoList, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt ) ; Autocopy stuff.
			Else
			   _ArrayAdd($aArray_FinishedList, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt ) ; Manual stuff we'll go through later.
			EndIf
		 Else
			_ArrayAdd($aArray_NotFound, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch ) ; Stuff that did not make the cut at all.
		 EndIf
	  EndIf

	  If $ExactHit = "TRUE" Then 										; If this was a direct hit (0) and the next Rom to check is not the same as this, we can remove this hit from the Sourcenames array to speed up search.
		 If $SourcesToCheck > "50" Then									; No point in removing anything from the sources array if its less then 50 items in it.
			If $i+1 < $RomsToCheck Then									; Make sure there are one more item in coming up in the rom array.
			   $RomNameNextClean = $aArray_RomsListCleaned[$i+1][1] 	; Grab the next rom thats coming up.
			   If $RomNameClean <> $RomNameNextClean Then 				; If the current rom is NOT the same as the next rom, we can remove this source from the source array to speed up searches.
				  _ArrayDelete($aArray_SourceListCleaned, $bestMatchIdx); Delete this item from array.
			   EndIf
			EndIf
		 EndIf
	  EndIf

   EndIf

Next

_ArrayDisplay($aArray_FinishedAutoList, "Here are the items that will now be automatically copied. Press X to continue.","",16,-1,"Rom Name Clean|Source Match Clean|Rom Full Name|Source Match Full Name|Misspellings|New Name", Default, 0xDDFFDD)

TrayTip("Copying", "Copying files within the autocopy limit. Hang on.",5)

For $i = 0 To UBound($aArray_FinishedAutoList) - 1

   $RomNameClean = $aArray_FinishedAutoList[$i][0]
   $BestMatchNameCleaned = $aArray_FinishedAutoList[$i][1]
   $RomName = $aArray_FinishedAutoList[$i][2]
   $BestMatchName = $aArray_FinishedAutoList[$i][3]
   $bestMatch = $aArray_FinishedAutoList[$i][4]
   $NewName = $aArray_FinishedAutoList[$i][5]

   If NOT FileExists($SourceFolder & "\" & $BestMatchName) Then
	  MsgBox(16, "Failure", "Could not find" & @CRLF & $SourceFolder & "\" & $BestMatchName & @CRLF & @CRLF & "Skipping it.")
   ElseIf NOT FileExists($DestinationFolder) Then
	  MsgBox(16, "Failure", "Could not find destinationfolder" & @CRLF & $DestinationFolder & @CRLF & @CRLF & "Skipping it.")
   Else
	  TrayTip($NewName, "Copying files within the autocopy limit. Hang on.",5)
	  ConsoleWrite(StringFormat("Autocopy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
	  FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
   EndIf
Next

_ArrayDisplay($aArray_FinishedList, "Here are the items that we will go over now. Press X to continue.","",16,-1,"Rom Name Clean|Source Match Clean|Rom Full Name|Source Match Full Name|Misspellings|New Name", Default, 0xDDFFDD)

For $i = 0 To UBound($aArray_FinishedList) - 1
   $RomNameClean = $aArray_FinishedList[$i][0]
   $BestMatchNameCleaned = $aArray_FinishedList[$i][1]
   $RomName = $aArray_FinishedList[$i][2]
   $BestMatchName = $aArray_FinishedList[$i][3]
   $bestMatch = $aArray_FinishedList[$i][4]
   $NewName = $aArray_FinishedList[$i][5]

   $Reply = MsgBox(3 + 32, "Is this a match?", "Would you say that these match?" & @CRLF & @CRLF & $RomNameClean & @CRLF & $BestMatchNameCleaned & @CRLF & @CRLF & "Exact names are:" & @CRLF & $RomName & @CRLF & $BestMatchName & @CRLF & @CRLF & "Misspellings: " & $bestMatch)
   If $Reply = "2" Then
	  Exit
   EndIf
   If $Reply = "7" Then
	  ConsoleWrite(StringFormat("Skipping: " & $BestMatchName & "\n"))
   EndIf
   If $Reply = "6" Then
	  ConsoleWrite(StringFormat("Manual copy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
	  FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
   EndIf
Next

_ArrayDisplay($aArray_NotFound, "Here are the best matches for unmatched media. Press X to quit the program.","",16,-1,"Rom Name Clean|Best Match Clean|Rom Full Name|Best Match Full Name|Misspellings", Default, 0xDDFFDD)

MsgBox(0, "Done", "All done!")

Func RemoveExtRegExp($Input)
   Return StringRegExpReplace($Input, "\.[^.]*$", "")
EndFunc

Func _FileGetExt($sPath)
    Local $NULL, $sExt
    _PathSplit($sPath, $NULL, $NULL, $NULL, $sExt)
    Return $sExt
EndFunc

 ; This function is called whenever you quit the script.
Func _Quit()
   Exit
EndFunc   ;==>_Quit